## dpuser 3.3%2Bp1%2Bdfsg

=== debian/changelog ===
dpuser (3.3+p1+dfsg-2build1) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 00:09:39 +0000

dpuser (3.3+p1+dfsg-2) unstable; urgency=medium

  * Force LC_NUMERIC locale to "C". (Closes: #858094)

 -- Ole Streicher <olebole@debian.org>  Sat, 18 Mar 2017 13:57:17 +0100

dpuser (3.3+p1+dfsg-1) unstable; urgency=medium

  * Import version 3.3+p1+dfsg patched by upstream

 -- Ole Streicher <olebole@debian.org>  Wed, 27 Jul 2016 14:15:37 +0200

dpuser (3.3+dfsg-1) unstable; urgency=low

  * Imported Upstream version 3.3+dfsg

 -- Ole Streicher <olebole@debian.org>  Mon, 25 Jul 2016 17:23:00 +0200

dpuser (3.2+dfsg-3) unstable; urgency=medium

  * Fix several segfaults

 -- Ole Streicher <olebole@debian.org>  Sat, 23 Jul 2016 13:56:07 +0200

dpuser (3.2+dfsg-2) unstable; urgency=medium

  * Fix crash on i386 and other platforms

 -- Ole Streicher <olebole@debian.org>  Fri, 22 Jul 2016 14:56:22 +0200

dpuser (3.2+dfsg-1) unstable; urgency=low

  * Initial release. (Closes: #472961)

 -- Ole Streicher <olebole@debian.org>  Mon, 04 Jul 2016 12:58:07 +0200
