=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT=qt5

%:
	dh  $@

override_dh_auto_build:
	$(MAKE) -C dpuser
	$(MAKE) -C QFitsView release_shared

override_dh_auto_test:
	cd dpuser/test && echo @testsuite.dpuser | ../dpuser | tee ../../test.log
	fgrep -q CONGRATULATIONS test.log

override_dh_installdocs:
	cd dpuser/doc && echo @makehelp.dpuser | ../../dpuser/dpuser
	cd QFitsView/doc/www && echo @makewww.dpuser | ../../../dpuser/dpuser
	test -f dpuser/doc/www/index.html
	dh_installdocs

override_dh_clean:
	$(MAKE) -C dpuser clean
	$(MAKE) -C QFitsView clean
	dh_clean
