=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3
opts=dversionmangle=s/\+dfsg//,repacksuffix=+dfsg \
 http://www.mpe.mpg.de/~ott/dpuser/dpuser.html .*dpuser.*src[_-]?(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
