=== dpuser/parser/Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
    endif
 
    ifeq ($(PLATFORM), LINUX)
-      YACC = ../../bin/LINUX$(ARCH)/yacc
+      YACC = ../../bin/LINUX$(ARCH)/yacc -d
       LEX  = flex -l
       SED  = sed -i''
    endif
@@ -38,11 +38,13 @@
 
 dpuser-parser: y.tab.cpp lex.yy.cpp
 
-y.tab.cpp: dpuser.y
+#y.tab.cpp: dpuser.y
+y.tab.cpp: ast.y
 	$(YACC) -d $<
 	$(MV) y.tab.c y.tab.cpp
 
-lex.yy.cpp: dpuser.l
+#lex.yy.cpp: dpuser.l
+lex.yy.cpp: ast.l
 	$(LEX) $<
 	$(MV) lex.yy.c lex.yy.cpp
 # resolve the isatty problem (only LINUX and MAC)
