=== debian/changelog ===
dpuser (4.0+dfsg-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_configure run the right qmake (Closes: #946284)

  [ Ole Streicher ]
  * Add missing QPainterPath header (Closes: #975171)

 -- Ole Streicher <olebole@debian.org>  Thu, 19 Nov 2020 11:35:27 +0100

dpuser (4.0+dfsg-2) unstable; urgency=low

  [ Helmut Grohne ]
  * Improve cross building: Build dpuser with the right compiler.
    (Closes: #939518)

  [ Ole Streicher ]
  * Propagate CPPFLAGS for dpuser build
  * Build doc only for -all architecture
  * Wrap inclusion of .xpm files with 'extern "C"'
  * Remove VTK references in patches
  * Add icon for QFitsView
  * Make dpuser-doc Multi-Arch:foreign

 -- Ole Streicher <olebole@debian.org>  Thu, 12 Sep 2019 21:24:15 +0200

dpuser (4.0+dfsg-1) unstable; urgency=low

  * Update VCS fields to use salsa.d.o
  * Add gitlab-CI
  * Fix documentation path
  * New upstream version 4.0+dfsg
  * Rediff patches
  * Push Standards-Version to 4.4.0. Change URLs to https
  * Push compat to 12. Remove d/compat
  * Workaround gcc optimization bug
  * Use fftw3, update qt5; remove vtk build deps
  * Fix test scripts
  * Wrap override_dh_auto_test with DEB_BUILD_OPTIONS

 -- Ole Streicher <olebole@debian.org>  Wed, 04 Sep 2019 20:56:42 +0200
