=== debian/rules ===
--- 
+++ 
@@ -9,14 +9,17 @@
 	dh  $@
 
 override_dh_auto_build:
-	$(MAKE) -C dpuser
-	$(MAKE) -C QFitsView release_shared
+	dh_auto_build --sourcedirectory=dpuser --no-parallel
+	dh_auto_configure --buildsystem=qmake --sourcedirectory=QFitsView -- "CONFIG+=release qf_shared"
+	dh_auto_build --buildsystem=qmake --sourcedirectory=QFitsView -- -f qfitsview.mk
 
+ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
 override_dh_auto_test:
 	cd dpuser/test && echo @testsuite.dpuser | ../dpuser | tee ../../test.log
 	fgrep -q CONGRATULATIONS test.log
+endif
 
-override_dh_installdocs:
+override_dh_installdocs-indep:
 	cd dpuser/doc && echo @makehelp.dpuser | ../../dpuser/dpuser
 	cd QFitsView/doc/www && echo @makewww.dpuser | ../../../dpuser/dpuser
 	test -f dpuser/doc/www/index.html
